function configuration_reporting (instance, widget) {
    "use strict";
    var widgets = widget;



    widget.ReportingWidget = instance.Widget.extend({
        template: 'EiruReporting',
        events: {
            'click .report_action > button': 'clickOnReport',
        },
        reports: [
            {
                title: 'Resumen de ingresos',
                description: 'Permite visualizar de forma global los ingresos obtenidos por la empresa.',
                action: 'ReportResumenIngreso'
            },
            {
                title: 'Resumen de egresos',
                description: 'Permite visualizar de forma global los egresos realizado por la empresa.',
                action: 'ReportResumenEngreso'
            },
            {
                title: 'Utilidad de facturas detalladas',
                description: 'Permite visualizar la ganancia de cada ítem de las facturas detalladamente.',
                action: 'ReportInvoiceUtility'
            },
            {
                title: 'Histórico de compras',
                description: 'Permite visualizar un histórico de compras realizado por la empresa.',
                action: 'AllPurchases'
            },
            {
                title: 'Histórico de gastos',
                description: 'Permite visualizar un histórico de gastos realizado por la empresa.',
                action: 'ReposrtExpenses'
            },
            {
                title: 'Listado de productos',
                description: 'Permite visualizar un listado de productos activos.',
                action: 'ReportStockProduct'
            },
            {
                title: 'Analisis de Cuotas Vencidas',
                description: 'Permite visualizar un listado de las cuotas vencidas',
                action: 'ReportExpired'
            },
            {
                title: 'Listado General de Stock',
                description: 'Permite visualizar todos los productos en el stock',
                action: 'ReportStockGral'
            }
        ],
        start: function () {
        },

        clickOnReport: function (e) {
            var templateName = this.$el.find(e.target).val();
            this.renderReport(templateName);
        },

        renderReport: function (templateName) {
            var Widget = this.getWidgetFromTemplate(templateName);
            var WidgetInstance = new Widget(this);
            var container = this.$el.find('.oe_form_sheet.oe_form_sheet_width');
            container.find('.report_view').hide({
                effect: 'fade',
                duration: 200,
                complete: function () {
                    WidgetInstance.appendTo(container);
                }
            });
        },

        getWidgetFromTemplate: function (templateName) {
            var widgetName = `${templateName}Widget`;
            return _.pick(widget, widgetName)[widgetName];
        },
    });
}
