function report_expired (reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportExpiredWidget = reporting.Base.extend({
        template : 'ReportExpired',
        content:[],
        rowsData:[],
        company:[],

        events : {
            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'click div > button' : 'clickOnAction',
            'change #current-journal': 'fecthSearch',
            'click-row.bs.table #table ' : 'ckickAnalysisDetail',
        },
        init : function(parent){
            this._super(parent);
        },
        start : function(){
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.fecthInitial();
        },
        ckickAnalysisDetail: function(e, row, $element,field){
            if (field == 'number'){
                this.do_action({
                    name:"Factura",
                    type: 'ir.actions.act_window',
                    res_model: "account.invoice",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }
            e.stopImmediatePropagation();
        },
        fecthInitial: function(){
            var self = this;
            self.fecthMoveLine().then(function(MoveLine){
                return MoveLine;
            }).then(function(MoveLine){
                self.MoveLine = _.filter(MoveLine, function(item) {
                    return item.amount_residual > 0;
                });
                return self.fetchAccountInvoice();
            }).then(function(AccountInvoice){
                self.AccountInvoice = AccountInvoice;
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                return self.fetchAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                self.$el.find('#current-journal').append('<option value="9999999">TODAS LAS SUC.</option>');
                _.each(AccountJournal, function (item) {
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.BuildTable();
            });
        },
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },
        fecthMoveLine : function(){
            var self = this;
            var hoy = moment().format('YYYY-MM-DD');
            var defer = $.Deferred();
            var MoveLine = new instance.web.Model('account.move.line');
            var fields = ['id','amount_residual', 'credit','date_maturity', 'invoice','ref', 'invoice', 'amount_residual_currency', 'currency_id'];
            var domain =[['credit', '<=', 0], ['date_maturity', '<=', hoy]];
            MoveLine.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },
        fetchAccountInvoice: function() {
            var self = this ;
            var defer = $.Deferred()
            var ref = _.map(self.MoveLine, function(map) {
                return map.invoice[0];
            });
            var fields = ['id','currency_id','number','partner_id','journal_id'];
            var domain = [['id', 'in', ref]];
            var AccountInvoice = new instance.web.Model('account.invoice');
            AccountInvoice.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchResCompany: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'currency_id'];
            var domain = [['id','=', 1]];
            var ResCompany = new instance.web.Model('res.company');
            ResCompany.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchAccountJournal: function () {
            var self = this;
            var defer = $.Deferred();
            var domain = [['type', '=', 'sale'],['active','=',true]];
            var Journal = new instance.web.Model('account.journal');
            Journal.query(['id', 'name']).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },
        getMoveLine: function(id) {
            var self = this;
            return _.filter(self.MoveLine,function (item) {
                return item.invoice[0] === id;
            });
        },
        getJournal: function (id) {
            var self = this;
            return _.filter(self.AccountJournal,function (item) {
                return item.id == id;
            });
        },
        BuildTable: function () {
            var self = this;
            self.company = self.ResCompany.shift();
            var data = [];
            var invoice = self.AccountInvoice
            var move;
            var amount;
            _.each(invoice, function(item){
                move = self.getMoveLine(item.id).shift();
                if (item.currency_id[0] ==  self.company.currency_id[0]) {
                    amount = accounting.formatNumber(Math.round(move.amount_residual),2,'.',',');
                }else{
                    amount = accounting.formatNumber(move.amount_residual_currency,0,'.',',');
                }
                data.push({
                    id : item.id,
                    number : item.number,
                    partner_id : item.partner_id[1],
                    date_maturity : moment(move.date_maturity).format("DD/MM/YYYY"),
                    currency_id : item.currency_id[1],
                    amount : amount,
                    value : move.amount_residual,
                    journal_id : item.journal_id[0],
                    date : move.date_maturity
                });
            });
            self.content = data;
            self.loadTable(data);
        },
        fecthSearch: function(){
            var self = this;
            var journal = this.$el.find('#current-journal').val();
            var desde = this.$el.find('#from').val();
            var hasta = this.$el.find('#to').val();
            var content = self.content;
            if (journal != 9999999){
                content=_.filter(content, function (inv){
                    return inv.journal_id == journal;
                });
            }
            if (desde.length > 0){
                var date= desde.split('/');
                content = _.filter(content, function (inv){
                    return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                });
            }
            if (hasta.length > 0){
                var date= hasta.split('/');
                content = _.filter(content, function (inv){
                    return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                });
            }
            self.loadTable(content);
        },
        loadTable:function(rowsTable){
            var self = this;
            this.rowsData=rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load' ,rowsTable);
        },
        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
        },
        getObjetPdf: function(){
            var self = this;
            var rows=[];
            var data = self.content;
            var journal = this.$el.find('#current-journal').val();
            var desde =this.$el.find('#from').val();
            var hasta =this.$el.find('#to').val();

            if (journal != 9999999){
                data=_.filter(data, function (inv){
                    return inv.journal_id == journal;
                });
            }
            if (desde.length > 0){
                var date= desde.split('/');
                data = _.filter(data, function (inv){
                    return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                });
            }
            if (hasta.length > 0){
                var date= desde.split('/');
                data = _.filter(data, function (inv){
                    return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                });
            }

            var value = _.reduce(_.map(data,function(map){
                return(map.value);
            }),function(memo, num){
                return memo + num;
            },0);
            
            data.push({
                number : 'Total',
                amount : accounting.formatNumber(value,2,'.',',')
            });
            
            rows = data;
            
            return rows;
        },
        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var journal = this.$el.find('#current-journal').val();
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    number : {columnWidth: '8px'},
                    partner_id : {columnWidth: '8px'},
                    date_maturity : {halign:'center',columnWidth: '8px'},
                    currency_id : {halign:'center',columnWidth: '8px'},
                    amount : {halign:'right',columnWidth: '8px'},
                },
                margin: { top: 30, horizontal: 7},

                addPageContent: function (data) {
                    pdfDoc.setFontSize(15);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Analisis de cuotas vencidas', data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde: '+ desde);
                        }
                        if (hasta){
                            fecha=fecha.concat('        Hasta: '+ hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, 130,20);
                    }
                    
                    if(journal != 9999999){
                        var sucursal = self.getJournal(journal).shift();
                        sucursal = 'Sucursal:   ' + sucursal.name;
                    }else{
                        sucursal = 'Sucursal:   Todas las Sucursales';
                    }
                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(sucursal, data.settings.margin.left,20);
                    
                    var total = 'Total en ' + self.company.currency_id[1] + ':  '+ rows[rows.length-1].amount;
                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(total, data.settings.margin.left,25);

                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                    }
            });
            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Analisis de cuotas vencidas')
        },
    });
}
